Index: code/branches/resource/src/core/IRC.cc
===================================================================
--- code/branches/resource/src/core/IRC.cc	(revision 3352)
+++ code/branches/resource/src/core/IRC.cc	(revision 3353)
@@ -57,8 +57,8 @@
         try
         {
-            this->interpreter_->def("orxonox::irc::say", IRC::tcl_say, Tcl::variadic());
-            this->interpreter_->def("orxonox::irc::privmsg", IRC::tcl_privmsg, Tcl::variadic());
-            this->interpreter_->def("orxonox::irc::action", IRC::tcl_action, Tcl::variadic());
-            this->interpreter_->def("orxonox::irc::info", IRC::tcl_info, Tcl::variadic());
+            this->interpreter_->def("::orxonox::irc::say", IRC::tcl_say, Tcl::variadic());
+            this->interpreter_->def("::orxonox::irc::privmsg", IRC::tcl_privmsg, Tcl::variadic());
+            this->interpreter_->def("::orxonox::irc::action", IRC::tcl_action, Tcl::variadic());
+            this->interpreter_->def("::orxonox::irc::info", IRC::tcl_info, Tcl::variadic());
         }
         catch (Tcl::tcl_error const &e)
Index: code/branches/resource/src/core/TclBind.cc
===================================================================
--- code/branches/resource/src/core/TclBind.cc	(revision 3352)
+++ code/branches/resource/src/core/TclBind.cc	(revision 3353)
@@ -79,17 +79,17 @@
             this->interpreter_ = this->createTclInterpreter();
 
-            this->interpreter_->def("orxonox::query", TclBind::tcl_query, Tcl::variadic());
-            this->interpreter_->def("orxonox::crossquery", TclThreadManager::tcl_crossquery, Tcl::variadic());
+            this->interpreter_->def("::orxonox::query", TclBind::tcl_query, Tcl::variadic());
+            this->interpreter_->def("::orxonox::crossquery", TclThreadManager::tcl_crossquery, Tcl::variadic());
             this->interpreter_->def("execute", TclBind::tcl_execute, Tcl::variadic());
-            this->interpreter_->def("orxonox::crossexecute", TclThreadManager::tcl_crossexecute, Tcl::variadic());
+            this->interpreter_->def("::orxonox::crossexecute", TclThreadManager::tcl_crossexecute, Tcl::variadic());
 
             try
             {
-                this->interpreter_->eval("proc query        {args}    { orxonox::query $args }");
-                this->interpreter_->eval("proc crossquery   {id args} { orxonox::crossquery 0 $id $args }");
-                this->interpreter_->eval("proc crossexecute {id args} { orxonox::crossquery 0 $id $args }");
+                this->interpreter_->eval("proc query        {args}    { ::orxonox::query $args }");
+                this->interpreter_->eval("proc crossquery   {id args} { ::orxonox::crossquery 0 $id $args }");
+                this->interpreter_->eval("proc crossexecute {id args} { ::orxonox::crossquery 0 $id $args }");
                 this->interpreter_->eval("proc running      {}        { return 1 }");
                 this->interpreter_->eval("set id 0");
-                this->interpreter_->eval("rename exit tcl::exit; proc exit {} { execute exit }");
+                this->interpreter_->eval("rename exit ::tcl::exit; proc exit {} { execute exit }");
             }
             catch (Tcl::tcl_error const &e)
Index: code/branches/resource/src/core/TclThreadManager.cc
===================================================================
--- code/branches/resource/src/core/TclThreadManager.cc	(revision 3352)
+++ code/branches/resource/src/core/TclThreadManager.cc	(revision 3353)
@@ -248,16 +248,16 @@
 
             // Define the functions which are implemented in C++
-            newbundle->interpreter_->def("orxonox::execute",      TclThreadManager::tcl_execute,      Tcl::variadic());
-            newbundle->interpreter_->def("orxonox::crossexecute", TclThreadManager::tcl_crossexecute, Tcl::variadic());
-            newbundle->interpreter_->def("orxonox::query",        TclThreadManager::tcl_query,        Tcl::variadic());
-            newbundle->interpreter_->def("orxonox::crossquery",   TclThreadManager::tcl_crossquery,   Tcl::variadic());
-            newbundle->interpreter_->def("orxonox::running",      TclThreadManager::tcl_running);
+            newbundle->interpreter_->def("::orxonox::execute",      TclThreadManager::tcl_execute,      Tcl::variadic());
+            newbundle->interpreter_->def("::orxonox::crossexecute", TclThreadManager::tcl_crossexecute, Tcl::variadic());
+            newbundle->interpreter_->def("::orxonox::query",        TclThreadManager::tcl_query,        Tcl::variadic());
+            newbundle->interpreter_->def("::orxonox::crossquery",   TclThreadManager::tcl_crossquery,   Tcl::variadic());
+            newbundle->interpreter_->def("::orxonox::running",      TclThreadManager::tcl_running);
 
             // Create threadspecific shortcuts for the functions above
             newbundle->interpreter_->def("execute",      TclThreadManager::tcl_execute,      Tcl::variadic());
             newbundle->interpreter_->def("crossexecute", TclThreadManager::tcl_crossexecute, Tcl::variadic());
-            newbundle->interpreter_->eval("proc query      {args}    { orxonox::query " + id_string + " $args }");
-            newbundle->interpreter_->eval("proc crossquery {id args} { orxonox::crossquery " + id_string + " $id $args }");
-            newbundle->interpreter_->eval("proc running    {}        { return [orxonox::running " + id_string + "] }");
+            newbundle->interpreter_->eval("proc query      {args}    { ::orxonox::query " + id_string + " $args }");
+            newbundle->interpreter_->eval("proc crossquery {id args} { ::orxonox::crossquery " + id_string + " $id $args }");
+            newbundle->interpreter_->eval("proc running    {}        { return [::orxonox::running " + id_string + "] }");
 
             // Define a variable containing the thread id
@@ -265,12 +265,12 @@
 
             // Use our own exit function to avoid shutting down the whole program instead of just the interpreter
-            newbundle->interpreter_->eval("rename exit tcl::exit");
+            newbundle->interpreter_->eval("rename exit ::tcl::exit");
             newbundle->interpreter_->eval("proc exit {} { execute TclThreadManager destroy " + id_string + " }");
 
             // Redefine some native functions
-            newbundle->interpreter_->eval("rename while tcl::while");
-            newbundle->interpreter_->eval("rename orxonox::while while");
-            newbundle->interpreter_->eval("rename for tcl::for");
-            newbundle->interpreter_->eval("rename orxonox::for for");
+            newbundle->interpreter_->eval("rename while ::tcl::while");
+            newbundle->interpreter_->eval("rename ::orxonox::while while");
+            newbundle->interpreter_->eval("rename for ::tcl::for");
+            newbundle->interpreter_->eval("rename ::orxonox::for for");
         }
         catch (const Tcl::tcl_error& e)