Index: /orxonox/branches/parenting/src/glmenu_imagescreen.cc
===================================================================
--- /orxonox/branches/parenting/src/glmenu_imagescreen.cc	(revision 3357)
+++ /orxonox/branches/parenting/src/glmenu_imagescreen.cc	(revision 3358)
@@ -18,5 +18,5 @@
 
 #include "glmenu_imagescreen.h"
-
+#include "importer/texture.h"
 
 using namespace std;
@@ -46,5 +46,27 @@
 */
 void GLMenuImageScreen::init ()
-{}
+{
+  int w = 680;
+  int h = 480;
+
+  glViewport(0,0,w,h);
+  
+  glMatrixMode(GL_PROJECTION);
+  glLoadIdentity(); 
+  gluPerspective(45.0f,(GLfloat)w/(GLfloat)h, .5f ,150.0f);
+  glMatrixMode(GL_MODELVIEW); 
+
+  this->backTex = new Texture();
+  this->backTex->loadImage("orx_tex.bmp");
+
+  /* ------------painten */
+
+  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+  glLoadIdentity();
+  gluLookAt(0, 0, 6,     0, 0, 0,     0, 1, 0);
+
+  // Bind the texture stored at the zero index of g_Texture[]
+  //glBindTexture(GL_TEXTURE_2D, g_Texture[0]);
+}
 
 
@@ -69,5 +91,31 @@
 */
 void GLMenuImageScreen::draw ()
-{}
+{
+  // Display a quad texture to the screen
+  glBegin(GL_QUADS);
+  
+  // Display the top left vertice
+  glTexCoord2f(0.0f, 1.0f);
+  glVertex3f(-2.5, 2.5, 0);
+  
+  // Display the bottom left vertice
+  glTexCoord2f(0.0f, 0.0f);
+  glVertex3f(-2.5, -2.5, 0);
+  
+  // Display the bottom right vertice
+  glTexCoord2f(1.0f, 0.0f);
+  glVertex3f(2.5, -2.5, 0);
+  
+  // Display the top right vertice
+  glTexCoord2f(1.0f, 1.0f);
+  glVertex3f(2.5, 2.5, 0);
+
+  glEnd();
+  
+  SDL_GL_SwapBuffers();                    
+
+  delete this->backTex;
+  SDL_Delay(1000);
+}
 
  
Index: /orxonox/branches/parenting/src/glmenu_imagescreen.h
===================================================================
--- /orxonox/branches/parenting/src/glmenu_imagescreen.h	(revision 3357)
+++ /orxonox/branches/parenting/src/glmenu_imagescreen.h	(revision 3358)
@@ -10,4 +10,5 @@
 #include "stdincl.h"
 
+class Texture;
 
 class GLMenuImageScreen : public BaseObject {
@@ -31,5 +32,6 @@
   float height, width;
   float offsetX, offsetY;
-
+  Texture* backTex;
+ 
 };
 
Index: /orxonox/branches/parenting/src/world.cc
===================================================================
--- /orxonox/branches/parenting/src/world.cc	(revision 3357)
+++ /orxonox/branches/parenting/src/world.cc	(revision 3358)
@@ -27,5 +27,5 @@
 #include "null_parent.h"
 #include "helper_parent.h"
-#include "importer/texture.h"
+#include "glmenu_imagescreen.h"
 
 using namespace std;
@@ -68,5 +68,5 @@
   this->nullParent->destroy ();
 
-  //delete this->testCurve;
+  //delete this->trackManager;
 
   /*
@@ -107,4 +107,5 @@
   //gluNurbsProperty (theNurb, GLU_NURBS_MODE, GLU_NURBS_TESSELLATOR);
   //gluNurbsProperty (theNurb, GLU_NURBS_VERTEX, vertexCallback );
+
 }
 
@@ -145,63 +146,8 @@
   printf ("World::displayLoadScreen - start\n"); 
   
-  int w = 680;
-  int h = 480;
-
-  glViewport(0,0,w,h);
-  
-  glMatrixMode(GL_PROJECTION);
-  glLoadIdentity(); 
-  gluPerspective(45.0f,(GLfloat)w/(GLfloat)h, .5f ,150.0f);
-  glMatrixMode(GL_MODELVIEW); 
-
-  Texture* loadScreenTexture = new Texture();
-  loadScreenTexture->loadImage("orx_tex.bmp");
-
-  /* ------------painten */
-
-  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-  glLoadIdentity();
-  gluLookAt(0, 0, 6,     0, 0, 0,     0, 1, 0);
-
-  // Bind the texture stored at the zero index of g_Texture[]
-  //glBindTexture(GL_TEXTURE_2D, g_Texture[0]);
-  
-  // Display a quad texture to the screen
-  glBegin(GL_QUADS);
-  
-  // glTexCoord2f() takes the X and Y offset (or U and V) into the bitmap.
-  // Then, the next point sent to be rendered attaches that part of the bitmap
-  // to itself.  The (U, V) coordinates range from (0, 0) being the top left corner
-  // of the bitmap, to (1, 1) being the bottom left corner of the bitmap.
-  // You can go above 1 but it just is wrapped around back to zero and repeats the texture.
-  // Try setting the 1's to 2's and see what it does, then try setting them to 0.5's.
-  // The higher the number, the more instances of the texture will appear on the square,
-  // Where the lower the number, it stretches the incomplete texture over the surface of the square.
-  // For every vertice we need a U V coordinate, as shown below.  You might have to play
-  // around with the values to make it texture correctly, otherwise it will be flipped, upside down,
-  // or skewed.  It also depends on where you are looking at it.  We are looking down the -Z axis.
-  
-  // Display the top left vertice
-  glTexCoord2f(0.0f, 1.0f);
-  glVertex3f(-2.5, 2.5, 0);
-  
-  // Display the bottom left vertice
-  glTexCoord2f(0.0f, 0.0f);
-  glVertex3f(-2.5, -2.5, 0);
-  
-  // Display the bottom right vertice
-  glTexCoord2f(1.0f, 0.0f);
-  glVertex3f(2.5, -2.5, 0);
-  
-  // Display the top right vertice
-  glTexCoord2f(1.0f, 1.0f);
-  glVertex3f(2.5, 2.5, 0);
-
-  glEnd();
-  
-  SDL_GL_SwapBuffers();                    
-
-  delete loadScreenTexture;
-  SDL_Delay (1000);
+  GLMenuImageScreen* glmis = new GLMenuImageScreen();
+  glmis->init();
+  glmis->draw();
+ 
   printf ("World::displayLoadScreen - end\n"); 
 }